// SmileyAnimation.java
//
// ICS 21 / CSE 21 Summer 2012
// Lab Assignment 2
//
// Originally coded by Norm Jacobson, October 2006
// Minor modifications introduced by Alex Thornton, Summer 2009

import java.awt.Color;
import java.util.Random;


// A SmileyAnimation represents an animation in which a smiley face moves
// around in a graphics window, bouncing off of walls, changing directions
// and colors along the way.

public class SmileyAnimation
{
	// A representation of the window in which the animation appears
	private SmileyDisplay display;

	// The smiley face that is to be animated
	private SmileyFace movingSmiley;

	// An indication of the current direction that the smiley face should be
	// moving, separated into a horizontal (x) and a vertical (y) direction.
	// Each should have one of the following three values:
	//
	//     -1: move left (x) or up (y)
	//      0: don't move in this dimension
	//      1: move right (x) or up (y)
	private int xDirection;
	private int yDirection;

	// A random number generator that you'll use to choose directions
	// randomly.
	private Random generator;

	// A constant representing the number of milliseconds that the animation
	// should run.
	private static final long TIME_TO_RUN = 30000;


	// This constructor should initialize a few things:
	//
	// * Create the SmileyFace that is to be animated
	// * Paint the starting screen
	// * Set the initial direction of smiley movement (your choice)
	// * Initialize the random number generator
	public SmileyAnimation(SmileyDisplay d)
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}


	// getSmileyFace() returns the smiley face that is to be animated.
	public SmileyFace getSmileyFace()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}


	// animate() animates the smiley for the appropriate amount of time,
	// moving it and drawing the smiley repeatedly until time runs out.
	public void animate()
	{
		// Set the current time
		long startTime = System.currentTimeMillis();

		// Run the animation for TIME_TO_RUN milliseconds
		do
		{
			// Continue to move the smiley in the current direction until
			// it hits an edge.  When an edge is hit, swap the colors of
			// the smiley's face and the wall and change direction.
			//
			// Use pause() as needed to "slow down" the smiley so that
			// it does not zip across the screen so fast we can't see what
			// it's doing!

			
			// *** REPLACE THIS COMMENT WITH YOUR CODE ***
		}
		while (System.currentTimeMillis() - startTime < TIME_TO_RUN);
	}


	// hitSomething() returns true if any wall has been hit, false if no wall
	// has been hit.
	private boolean hitSomething()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}


	// adjustColorAndDirection() is to be called when a wall it hit.  It
	// swaps the color of the smiley's face and the wall that has been
	// hit; it also changes the direction as appropriate.
	//
	// (Use helper methods adjustColor() and adjustDirection() here.)
	private void adjustColorAndDirection()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}

	
	// adjustColor() swaps the color of the wall whose name is given by
	// wallHit with the color of the smiley's face.  The name of the wall
	// can be either "Left", "Right", "Top", or "Bottom".
	private void adjustColor(String wallHit)
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}
	
	
	// adjustDirection() changes the smiley's direction so that it moves
	// away from the wall it just hit; the name of the wall that was hit
	// is given by wallHit.  The name of the wall can be either "Left",
	// "Right", "Top", or "Bottom".
	private void adjustDirection(String wallHit)
	{
		// If the smiley has hit the top or bottom wall, the y-direction
		// should be reversed, while the new x-direction should be chosen
		// randomly to be either left, right, or no movement.
		//
		// If the smiley has hit the left or right wall, the x-direction
		// should be reversed, while the new y-direction should be chosen
		// randomly to be either up, down, or no movement.

		
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}

	
	// hitLeftWall() returns true if the left wall has been fit, false
	// otherwise.
	private boolean hitLeftWall()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}

	
	// hitRightWall() returns true if the right wall has been hit,
	// false otherwise.
	private boolean hitRightWall()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}
	
	
	// hitTopWall() returns true if the top wall has been hit, false
	// otherwise.
	private boolean hitTopWall()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}

	
	// hitBottomWall() returns true if the bottom wall has been hit,
	// false otherwise.
	private boolean hitBottomWall()
	{
		// *** REPLACE THIS COMMENT WITH YOUR CODE ***
	}


	// pause() waits the given number of milliseconds.  You can use this
	// method to pause between the frames of your animation.
	private void pause(long millisecondsToWait)
	{
		long startTime = System.currentTimeMillis();
		long endTime;

		do
		{
			endTime = System.currentTimeMillis();
		}
		while (endTime - startTime < millisecondsToWait);
	}
}
